/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_MEDIPRATO                                                */
/* Tabela : MEDIPRATO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2004 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MEDIPRATO'  and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_MEDIPRATO
  GO


CREATE TRIGGER DTULTATU_MEDIPRATO
ON MEDIPRATO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'MEDIPRATO', NULL, 'CDMEDICASE='+CDMEDICASE+';
                               CDFILAUXPRAT='+CDFILAUXPRAT+';CDPRATO='+CDPRATO+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MEDIPRATO
      SET DTULTATUMEPR = GETDATE()
      FROM INSERTED
      WHERE
         (MEDIPRATO.CDMEDICASE   = INSERTED.CDMEDICASE  ) AND
         (MEDIPRATO.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT) AND
         (MEDIPRATO.CDPRATO      = INSERTED.CDPRATO)
   END;
END;
GO